--- //depot/vendor/freebsd/src/sys/kern/uipc_socket2.c	2004/02/29 19:15:33
+++ //depot/user/rwatson/netperf/sys/kern/uipc_socket2.c	2004/02/29 21:00:26
@@ -108,9 +108,14 @@
 soisconnecting(so)
 	register struct socket *so;
 {
+	int need_lock = !SOCK_OWNED(so);
 
+	if (need_lock)
+		SOCK_LOCK(so);
 	so->so_state &= ~(SS_ISCONNECTED|SS_ISDISCONNECTING);
 	so->so_state |= SS_ISCONNECTING;
+	if (need_lock)
+		SOCK_UNLOCK(so);
 }
 
 void
@@ -118,56 +123,79 @@
 	struct socket *so;
 {
 	struct socket *head = so->so_head;
+	int need_lock = !SOCK_OWNED(so);
 
+	if (need_lock)
+		SOCK_LOCK(so);
 	so->so_state &= ~(SS_ISCONNECTING|SS_ISDISCONNECTING|SS_ISCONFIRMING);
 	so->so_state |= SS_ISCONNECTED;
 	if (head && (so->so_state & SS_INCOMP)) {
-		if ((so->so_options & SO_ACCEPTFILTER) != 0) {
+		if ((so->so_options & SO_ACCEPTFILTER) == 0) {
+			if (need_lock)
+				SOCK_UNLOCK(so);
+			SOCK_LOCK(head);
+			TAILQ_REMOVE(&head->so_incomp, so, so_list);
+			head->so_incqlen--;
+			so->so_state &= ~SS_INCOMP;
+			TAILQ_INSERT_TAIL(&head->so_comp, so, so_list);
+			head->so_qlen++;
+			so->so_state |= SS_COMP;
+			sorwakeup_locked(head);
+			wakeup_one(&head->so_timeo);
+			SOCK_UNLOCK(head);
+		} else {
+/* XXX locking */
 			so->so_upcall = head->so_accf->so_accept_filter->accf_callback;
 			so->so_upcallarg = head->so_accf->so_accept_filter_arg;
 			so->so_rcv.sb_flags |= SB_UPCALL;
 			so->so_options &= ~SO_ACCEPTFILTER;
 			so->so_upcall(so, so->so_upcallarg, M_TRYWAIT);
-			return;
 		}
-		TAILQ_REMOVE(&head->so_incomp, so, so_list);
-		head->so_incqlen--;
-		so->so_state &= ~SS_INCOMP;
-		TAILQ_INSERT_TAIL(&head->so_comp, so, so_list);
-		head->so_qlen++;
-		so->so_state |= SS_COMP;
-		sorwakeup(head);
-		wakeup_one(&head->so_timeo);
 	} else {
 		wakeup(&so->so_timeo);
+		SOCK_UNLOCK(so);
 		sorwakeup(so);
 		sowwakeup(so);
 	}
+	if (!need_lock)
+		SOCK_LOCK(so);
 }
 
 void
 soisdisconnecting(so)
 	register struct socket *so;
 {
+	int need_lock = !SOCK_OWNED(so);
 
+	if (need_lock)
+		SOCK_LOCK(so);
 	so->so_state &= ~SS_ISCONNECTING;
 	so->so_state |= (SS_ISDISCONNECTING|SS_CANTRCVMORE|SS_CANTSENDMORE);
 	wakeup(&so->so_timeo);
+	SOCK_UNLOCK(so);
 	sowwakeup(so);
 	sorwakeup(so);
+	if (!need_lock)
+		SOCK_LOCK(so);
 }
 
 void
 soisdisconnected(so)
 	register struct socket *so;
 {
+	int need_lock = !SOCK_OWNED(so);
 
+	if (need_lock)
+		SOCK_LOCK(so);
 	so->so_state &= ~(SS_ISCONNECTING|SS_ISCONNECTED|SS_ISDISCONNECTING);
 	so->so_state |= (SS_CANTRCVMORE|SS_CANTSENDMORE|SS_ISDISCONNECTED);
 	wakeup(&so->so_timeo);
+	SOCK_UNLOCK(so);
 	sbdrop(&so->so_snd, so->so_snd.sb_cc);
 	sowwakeup(so);
 	sorwakeup(so);
+	if (!need_lock)
+		SOCK_LOCK(so);
 }
 
 /*
@@ -186,8 +214,12 @@
 	int connstatus;
 {
 	register struct socket *so;
+	int over;
 
-	if (head->so_qlen > 3 * head->so_qlimit / 2)
+	SOCK_LOCK(head);
+	over = (head->so_qlen > 3 * head->so_qlimit / 2);
+	SOCK_UNLOCK(head);
+	if (over)
 		return ((struct socket *)0);
 	so = soalloc(M_NOWAIT);
 	if (so == NULL)
@@ -205,12 +237,13 @@
 #ifdef MAC
 	mac_create_socket_from_socket(head, so);
 #endif
+
 	if (soreserve(so, head->so_snd.sb_hiwat, head->so_rcv.sb_hiwat) ||
 	    (*so->so_proto->pr_usrreqs->pru_attach)(so, 0, NULL)) {
 		sodealloc(so);
 		return ((struct socket *)0);
 	}
-
+	SOCKBUF_LOCK(&head->so_rcv);
 	if (connstatus) {
 		TAILQ_INSERT_TAIL(&head->so_comp, so, so_list);
 		so->so_state |= SS_COMP;
@@ -225,10 +258,11 @@
 		so->so_state |= SS_INCOMP;
 		head->so_incqlen++;
 	}
+	SOCKBUF_UNLOCK(&head->so_rcv);
 	if (connstatus) {
+		so->so_state |= connstatus;
 		sorwakeup(head);
 		wakeup(&head->so_timeo);
-		so->so_state |= connstatus;
 	}
 	return (so);
 }
@@ -253,6 +287,16 @@
 }
 
 void
+socantsendmore_locked(so)
+	struct socket *so;
+{
+	SOCKBUF_LOCK_ASSERT(&so->so_snd);
+
+	so->so_state |= SS_CANTSENDMORE;
+	sowwakeup(so);
+}
+
+void
 socantrcvmore(so)
 	struct socket *so;
 {
@@ -261,6 +305,16 @@
 	sorwakeup(so);
 }
 
+void
+socantrcvmore_locked(so)
+	struct socket *so;
+{
+	SOCKBUF_LOCK_ASSERT(&so->so_rcv);
+
+	so->so_state |= SS_CANTRCVMORE;
+	sorwakeup_locked(so);
+}
+
 /*
  * Wait for data to arrive at/drain from a socket buffer.
  */
@@ -268,9 +322,10 @@
 sbwait(sb)
 	struct sockbuf *sb;
 {
+	SOCKBUF_LOCK_ASSERT(sb);
 
 	sb->sb_flags |= SB_WAIT;
-	return (tsleep(&sb->sb_cc,
+	return (msleep(&sb->sb_cc, &sb->sb_mtx,
 	    (sb->sb_flags & SB_NOINTR) ? PSOCK : PSOCK | PCATCH, "sbwait",
 	    sb->sb_timeo));
 }
@@ -285,9 +340,11 @@
 {
 	int error;
 
+	SOCKBUF_LOCK_ASSERT(sb);
+
 	while (sb->sb_flags & SB_LOCK) {
 		sb->sb_flags |= SB_WANT;
-		error = tsleep(&sb->sb_flags,
+		error = msleep(&sb->sb_flags, &sb->sb_mtx,
 		    (sb->sb_flags & SB_NOINTR) ? PSOCK : PSOCK|PCATCH,
 		    "sblock", 0);
 		if (error)
@@ -298,29 +355,71 @@
 }
 
 /*
+ * The part of sowakeup that must be done while
+ * holding the sockbuf lock.
+ */
+static __inline void
+sowakeup_under_lock(struct socket *so, struct sockbuf *sb)
+{
+	SOCKBUF_LOCK_ASSERT(sb);
+
+	selwakeuppri(&sb->sb_sel, PSOCK);
+	sb->sb_flags &= ~SB_SEL;
+	if (sb->sb_flags & SB_WAIT) {
+		sb->sb_flags &= ~SB_WAIT;
+		wakeup(&sb->sb_cc);
+	}
+}
+
+/*
  * Wakeup processes waiting on a socket buffer.
  * Do asynchronous notification via SIGIO
  * if the socket has the SS_ASYNC flag set.
+ *
+ * The caller is assumed to hold the necessary
+ * sockbuf lock.
  */
 void
+sowakeup_locked(so, sb)
+	register struct socket *so;
+	register struct sockbuf *sb;
+{
+
+	sowakeup_under_lock(so, sb);
+
+	if ((so->so_state & SS_ASYNC) && so->so_sigio != NULL)
+		pgsigio(&so->so_sigio, SIGIO, 0);
+	if (sb->sb_flags & SB_UPCALL)
+		(*so->so_upcall)(so, so->so_upcallarg, M_DONTWAIT);
+	if (sb->sb_flags & SB_AIO)		/* XXX locking */
+		aio_swake(so, sb);
+	KNOTE(&sb->sb_sel.si_note, 0);		/* XXX locking? */
+}
+
+/*
+ * Wakeup processes waiting on a socket buffer.
+ * Do asynchronous notification via SIGIO
+ * if the socket has the SS_ASYNC flag set.
+ *
+ * The caller does not hold the sockbuf lock.
+ */
+void
 sowakeup(so, sb)
 	register struct socket *so;
 	register struct sockbuf *sb;
 {
 
-	selwakeuppri(&sb->sb_sel, PSOCK);
-	sb->sb_flags &= ~SB_SEL;
-	if (sb->sb_flags & SB_WAIT) {
-		sb->sb_flags &= ~SB_WAIT;
-		wakeup(&sb->sb_cc);
-	}
+	SOCKBUF_LOCK(sb);
+	sowakeup_under_lock(so, sb);
+	SOCKBUF_UNLOCK(sb);
+
 	if ((so->so_state & SS_ASYNC) && so->so_sigio != NULL)
 		pgsigio(&so->so_sigio, SIGIO, 0);
 	if (sb->sb_flags & SB_UPCALL)
 		(*so->so_upcall)(so, so->so_upcallarg, M_DONTWAIT);
-	if (sb->sb_flags & SB_AIO)
+	if (sb->sb_flags & SB_AIO)		/* XXX locking */
 		aio_swake(so, sb);
-	KNOTE(&sb->sb_sel.si_note, 0);
+	KNOTE(&sb->sb_sel.si_note, 0);		/* XXX locking? */
 }
 
 /*
@@ -480,6 +579,8 @@
 {
 	struct mbuf *m = sb->sb_mb;
 
+	SOCKBUF_LOCK_ASSERT(sb);
+
 	while (m && m->m_nextpkt)
 		m = m->m_nextpkt;
 
@@ -499,6 +600,8 @@
 	struct mbuf *m = sb->sb_mb;
 	struct mbuf *n;
 
+	SOCKBUF_LOCK_ASSERT(sb);
+
 	while (m && m->m_nextpkt)
 		m = m->m_nextpkt;
 
@@ -535,7 +638,7 @@
  * discarded and mbufs are compacted where possible.
  */
 void
-sbappend(sb, m)
+sbappend_locked(sb, m)
 	struct sockbuf *sb;
 	struct mbuf *m;
 {
@@ -543,6 +646,9 @@
 
 	if (m == 0)
 		return;
+
+	SOCKBUF_LOCK_ASSERT(sb);
+
 	SBLASTRECORDCHK(sb);
 	n = sb->sb_mb;
 	if (n) {
@@ -550,7 +656,7 @@
 			n = n->m_nextpkt;
 		do {
 			if (n->m_flags & M_EOR) {
-				sbappendrecord(sb, m); /* XXXXXX!!!! */
+				sbappendrecord_locked(sb, m); /* XXXXXX!!!! */
 				return;
 			}
 		} while (n->m_next && (n = n->m_next));
@@ -563,7 +669,7 @@
 		if ((n = sb->sb_lastrecord) != NULL) {
 			do {
 				if (n->m_flags & M_EOR) {
-					sbappendrecord(sb, m); /* XXXXXX!!!! */
+					sbappendrecord_locked(sb, m); /* XXXXXX!!!! */
 					return;
 				}
 			} while (n->m_next && (n = n->m_next));
@@ -580,13 +686,33 @@
 }
 
 /*
+ * Append mbuf chain m to the last record in the
+ * socket buffer sb.  The additional space associated
+ * the mbuf chain is recorded in sb.  Empty mbufs are
+ * discarded and mbufs are compacted where possible.
+ */
+void
+sbappend(sb, m)
+	struct sockbuf *sb;
+	struct mbuf *m;
+{
+	if (!SOCKBUF_OWNED(sb)) {
+		SOCKBUF_LOCK(sb);
+		sbappend_locked(sb, m);
+		SOCKBUF_UNLOCK(sb);
+	} else
+		sbappend_locked(sb, m);
+}
+
+/*
  * This version of sbappend() should only be used when the caller
  * absolutely knows that there will never be more than one record
  * in the socket buffer, that is, a stream protocol (such as TCP).
  */
 void
-sbappendstream(struct sockbuf *sb, struct mbuf *m)
+sbappendstream_locked(struct sockbuf *sb, struct mbuf *m)
 {
+	SOCKBUF_LOCK_ASSERT(sb);
 
 	KASSERT(m->m_nextpkt == NULL,("sbappendstream 0"));
 	KASSERT(sb->sb_mb == sb->sb_lastrecord,("sbappendstream 1"));
@@ -596,13 +722,28 @@
 #ifdef MBUFTRACE
 	m_claim(m, sb->sb_mowner);
 #endif
-
 	sbcompress(sb, m, sb->sb_mbtail);
 
 	sb->sb_lastrecord = sb->sb_mb;
 	SBLASTRECORDCHK(sb);
 }
 
+/*
+ * This version of sbappend() should only be used when the caller
+ * absolutely knows that there will never be more than one record
+ * in the socket buffer, that is, a stream protocol (such as TCP).
+ */
+void
+sbappendstream(struct sockbuf *sb, struct mbuf *m)
+{
+	if (!SOCKBUF_OWNED(sb)) {
+		SOCKBUF_LOCK(sb);
+		sbappendstream_locked(sb, m);
+		SOCKBUF_UNLOCK(sb);
+	} else
+		sbappendstream_locked(sb, m);
+}
+
 #ifdef SOCKBUF_DEBUG
 void
 sbcheck(sb)
@@ -612,6 +753,8 @@
 	struct mbuf *n = 0;
 	u_long len = 0, mbcnt = 0;
 
+	SOCKBUF_LOCK_ASSERT(sb);
+
 	for (m = sb->sb_mb; m; m = n) {
 	    n = m->m_nextpkt;
 	    for (; m; m = m->m_next) {
@@ -634,12 +777,14 @@
  * begins a new record.
  */
 void
-sbappendrecord(sb, m0)
+sbappendrecord_locked(sb, m0)
 	register struct sockbuf *sb;
 	register struct mbuf *m0;
 {
 	register struct mbuf *m;
 
+	SOCKBUF_LOCK_ASSERT(sb);
+
 	if (m0 == 0)
 		return;
 	m = sb->sb_mb;
@@ -667,18 +812,37 @@
 }
 
 /*
+ * As above, except the mbuf chain
+ * begins a new record.
+ */
+void
+sbappendrecord(sb, m0)
+	register struct sockbuf *sb;
+	register struct mbuf *m0;
+{
+	if (!SOCKBUF_OWNED(sb)) {
+		SOCKBUF_LOCK(sb);
+		sbappendrecord_locked(sb, m0);
+		SOCKBUF_UNLOCK(sb);
+	} else
+		sbappendrecord_locked(sb, m0);
+}
+
+/*
  * As above except that OOB data
  * is inserted at the beginning of the sockbuf,
  * but after any other OOB data.
  */
 void
-sbinsertoob(sb, m0)
+sbinsertoob_locked(sb, m0)
 	register struct sockbuf *sb;
 	register struct mbuf *m0;
 {
 	register struct mbuf *m;
 	register struct mbuf **mp;
 
+	SOCKBUF_LOCK_ASSERT(sb);
+
 	if (m0 == 0)
 		return;
 	for (mp = &sb->sb_mb; *mp ; mp = &((*mp)->m_nextpkt)) {
@@ -713,13 +877,31 @@
 }
 
 /*
+ * As above except that OOB data
+ * is inserted at the beginning of the sockbuf,
+ * but after any other OOB data.
+ */
+void
+sbinsertoob(sb, m0)
+	register struct sockbuf *sb;
+	register struct mbuf *m0;
+{
+	if (!SOCKBUF_OWNED(sb)) {
+		SOCKBUF_LOCK(sb);
+		sbinsertoob_locked(sb, m0);
+		SOCKBUF_UNLOCK(sb);
+	} else
+		sbinsertoob_locked(sb, m0);
+}
+
+/*
  * Append address and data, and optionally, control (ancillary) data
  * to the receive queue of a socket.  If present,
  * m0 must include a packet header with total length.
  * Returns 0 if no space in sockbuf or insufficient mbufs.
  */
 int
-sbappendaddr(sb, asa, m0, control)
+sbappendaddr_locked(sb, asa, m0, control)
 	struct sockbuf *sb;
 	struct sockaddr *asa;
 	struct mbuf *m0, *control;
@@ -727,11 +909,14 @@
 	struct mbuf *m, *n, *nlast;
 	int space = asa->sa_len;
 
+	SOCKBUF_LOCK_ASSERT(sb);
+
 	if (m0 && (m0->m_flags & M_PKTHDR) == 0)
 		panic("sbappendaddr");
 	if (m0)
 		space += m0->m_pkthdr.len;
 	space += m_length(control, &n);
+
 	if (space > sbspace(sb))
 		return (0);
 #if MSIZE <= 256
@@ -753,25 +938,50 @@
 	sballoc(sb, n);
 	nlast = n;
 	SBLINKRECORD(sb, m);
+	sb->sb_mbtail = nlast;
 
-	sb->sb_mbtail = nlast;
 	SBLASTMBUFCHK(sb);
-
 	SBLASTRECORDCHK(sb);
 	return (1);
 }
 
+/*
+ * Append address and data, and optionally, control (ancillary) data
+ * to the receive queue of a socket.  If present,
+ * m0 must include a packet header with total length.
+ * Returns 0 if no space in sockbuf or insufficient mbufs.
+ */
+int
+sbappendaddr(sb, asa, m0, control)
+	struct sockbuf *sb;
+	struct sockaddr *asa;
+	struct mbuf *m0, *control;
+{
+	int retval;
+
+	if (!SOCKBUF_OWNED(sb)) {
+		SOCKBUF_LOCK(sb);
+		retval = sbappendaddr_locked(sb, asa, m0, control);
+		SOCKBUF_UNLOCK(sb);
+	} else
+		retval = sbappendaddr_locked(sb, asa, m0, control);
+	return (retval);
+}
+
 int
-sbappendcontrol(sb, m0, control)
+sbappendcontrol_locked(sb, m0, control)
 	struct sockbuf *sb;
 	struct mbuf *control, *m0;
 {
 	struct mbuf *m, *n, *mlast;
 	int space;
 
+	SOCKBUF_LOCK_ASSERT(sb);
+
 	if (control == 0)
 		panic("sbappendcontrol");
 	space = m_length(control, &n) + m_length(m0, NULL);
+
 	if (space > sbspace(sb))
 		return (0);
 	n->m_next = m0;			/* concatenate data to control */
@@ -783,14 +993,30 @@
 	sballoc(sb, m);
 	mlast = m;
 	SBLINKRECORD(sb, control);
+	sb->sb_mbtail = mlast;
 
-	sb->sb_mbtail = mlast;
 	SBLASTMBUFCHK(sb);
+	SBLASTRECORDCHK(sb);
 
-	SBLASTRECORDCHK(sb);
 	return (1);
 }
 
+int
+sbappendcontrol(sb, m0, control)
+	struct sockbuf *sb;
+	struct mbuf *control, *m0;
+{
+	int retval;
+
+	if (!SOCKBUF_OWNED(sb)) {
+		SOCKBUF_LOCK(sb);
+		retval = sbappendcontrol(sb, m0, control);
+		SOCKBUF_UNLOCK(sb);
+	} else
+		retval = sbappendcontrol(sb, m0, control);
+	return (retval);
+}
+
 /*
  * Compress mbuf chain m into the socket
  * buffer sb following mbuf n.  If n
@@ -804,6 +1030,8 @@
 	register int eor = 0;
 	register struct mbuf *o;
 
+	SOCKBUF_LOCK_ASSERT(sb);
+
 	while (m) {
 		eor |= m->m_flags & M_EOR;
 		if (m->m_len == 0 &&
@@ -872,7 +1100,8 @@
 		sbdrop(sb, (int)sb->sb_cc);
 	}
 	if (sb->sb_cc || sb->sb_mb || sb->sb_mbcnt)
-		panic("sbflush: cc %u || mb %p || mbcnt %u", sb->sb_cc, (void *)sb->sb_mb, sb->sb_mbcnt);
+		panic("sbflush: cc %u || mb %p || mbcnt %u",
+			sb->sb_cc, (void *)sb->sb_mb, sb->sb_mbcnt);
 }
 
 /*
@@ -885,7 +1114,11 @@
 {
 	register struct mbuf *m;
 	struct mbuf *next;
+	int need_lock = !SOCKBUF_OWNED(sb);
 
+	if (need_lock)
+		SOCKBUF_LOCK(sb);
+
 	next = (m = sb->sb_mb) ? m->m_nextpkt : 0;
 	while (len > 0) {
 		if (m == 0) {
@@ -929,6 +1162,9 @@
 	} else if (m->m_nextpkt == NULL) {
 		sb->sb_lastrecord = m;
 	}
+
+	if (need_lock)
+		SOCKBUF_UNLOCK(sb);
 }
 
 /*
@@ -940,7 +1176,11 @@
 	register struct sockbuf *sb;
 {
 	register struct mbuf *m;
+	int need_lock = !SOCKBUF_OWNED(sb);
 
+	if (need_lock)
+		SOCKBUF_LOCK(sb);
+
 	m = sb->sb_mb;
 	if (m) {
 		sb->sb_mb = m->m_nextpkt;
@@ -950,6 +1190,9 @@
 		} while (m);
 	}
 	SB_EMPTY_FIXUP(sb);
+
+	if (need_lock)
+		SOCKBUF_UNLOCK(sb);
 }
 
 /*
--- //depot/vendor/freebsd/src/sys/kern/uipc_syscalls.c	2004/03/03 18:00:46
+++ //depot/user/rwatson/netperf/sys/kern/uipc_syscalls.c	2004/03/03 21:04:46
@@ -117,10 +117,10 @@
 	if (error)
 		return (error);
 	/* An extra reference on `fp' has been held for us by falloc(). */
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	error = socreate(uap->domain, &so, uap->type, uap->protocol,
 	    td->td_ucred, td);
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	FILEDESC_LOCK(fdp);
 	if (error) {
 		if (fdp->fd_ofiles[fd] == fp) {
@@ -174,10 +174,11 @@
 	struct socket *so;
 	int error;
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, fd, &so, NULL)) != 0)
 		goto done2;
 #ifdef MAC
+	/* XXXRW: MAC requires socket lock? */
 	error = mac_check_socket_bind(td->td_ucred, so, sa);
 	if (error)
 		goto done1;
@@ -188,7 +189,7 @@
 #endif
 	fputsock(so);
 done2:
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	FREE(sa, M_SONAME);
 	return (error);
 }
@@ -208,9 +209,10 @@
 	struct socket *so;
 	int error;
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, uap->s, &so, NULL)) == 0) {
 #ifdef MAC
+		/* XXXRW: MAC requires socket lock? */
 		error = mac_check_socket_listen(td->td_ucred, so);
 		if (error)
 			goto done;
@@ -221,7 +223,7 @@
 #endif
 		fputsock(so);
 	}
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	return(error);
 }
 
@@ -260,12 +262,14 @@
 			goto done3;
 		}
 	}
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	error = fgetsock(td, uap->s, &head, &fflag);
 	if (error)
 		goto done2;
 	s = splnet();
+	SOCK_LOCK(head);
 	if ((head->so_options & SO_ACCEPTCONN) == 0) {
+		SOCK_UNLOCK(head);
 		splx(s);
 		error = EINVAL;
 		goto done;
@@ -279,9 +283,10 @@
 			head->so_error = EWOULDBLOCK;
 			break;
 		}
-		error = tsleep(&head->so_timeo, PSOCK | PCATCH,
+		error = msleep(&head->so_timeo, SOCK_MTX(head), PSOCK | PCATCH,
 		    "accept", 0);
 		if (error) {
+			SOCK_UNLOCK(head);
 			splx(s);
 			goto done;
 		}
@@ -289,6 +294,7 @@
 	if (head->so_error) {
 		error = head->so_error;
 		head->so_error = 0;
+		SOCK_UNLOCK(head);
 		splx(s);
 		goto done;
 	}
@@ -298,11 +304,13 @@
 	 * ready to be accepted. Remove it from the queue prior to
 	 * allocating the file descriptor for it since falloc() may
 	 * block allowing another process to accept the connection
-	 * instead.
+	 * instead.  The reference previously owned by the socket queue
+	 * is now thread-local, letting us release the lock on the head.
 	 */
 	so = TAILQ_FIRST(&head->so_comp);
 	TAILQ_REMOVE(&head->so_comp, so, so_list);
 	head->so_qlen--;
+	SOCK_UNLOCK(head);
 
 	error = falloc(td, &nfp, &fd);
 	if (error) {
@@ -310,20 +318,27 @@
 		 * Probably ran out of file descriptors. Put the
 		 * unaccepted connection back onto the queue and
 		 * do another wakeup so some other process might
-		 * have a chance at it.
+		 * have a chance at it.  Note that strict ordering
+		 * is lost.
 		 */
+		SOCK_LOCK(head);
 		TAILQ_INSERT_HEAD(&head->so_comp, so, so_list);
 		head->so_qlen++;
 		wakeup_one(&head->so_timeo);
+		SOCK_UNLOCK(head);
 		splx(s);
 		goto done;
 	}
 	/* An extra reference on `nfp' has been held for us by falloc(). */
 	td->td_retval[0] = fd;
 
+	/* XXX lock? */
 	/* connection has been removed from the listen queue */
 	KNOTE(&head->so_rcv.sb_sel.si_note, 0);
 
+	/*
+	 * XXXRW: so should be locked to modify so_state here?
+	 */
 	so->so_state &= ~SS_COMP;
 	so->so_head = NULL;
 	pgid = fgetown(&head->so_sigio);
@@ -408,7 +423,7 @@
 		fdrop(nfp, td);
 	fputsock(head);
 done2:
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 done3:
 	return (error);
 }
@@ -473,7 +488,7 @@
 	int error, s;
 	int interrupted = 0;
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, fd, &so, NULL)) != 0)
 		goto done2;
 	if (so->so_state & SS_ISCONNECTING) {
@@ -481,6 +496,7 @@
 		goto done1;
 	}
 #ifdef MAC
+	/* XXXRW: MAC requires socket lock? */
 	error = mac_check_socket_connect(td->td_ucred, so, sa);
 	if (error)
 		goto bad;
@@ -493,8 +509,10 @@
 		goto done1;
 	}
 	s = splnet();
+	SOCK_LOCK(so);
 	while ((so->so_state & SS_ISCONNECTING) && so->so_error == 0) {
-		error = tsleep(&so->so_timeo, PSOCK | PCATCH, "connec", 0);
+		error = msleep(&so->so_timeo, SOCK_MTX(so), PSOCK | PCATCH,
+		    "connec", 0);
 		if (error) {
 			if (error == EINTR || error == ERESTART)
 				interrupted = 1;
@@ -505,6 +523,7 @@
 		error = so->so_error;
 		so->so_error = 0;
 	}
+	SOCK_UNLOCK(so);
 	splx(s);
 bad:
 	if (!interrupted)
@@ -514,7 +533,7 @@
 done1:
 	fputsock(so);
 done2:
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	FREE(sa, M_SONAME);
 	return (error);
 }
@@ -537,7 +556,7 @@
 	struct socket *so1, *so2;
 	int fd, error, sv[2];
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	error = socreate(uap->domain, &so1, uap->type, uap->protocol,
 	    td->td_ucred, td);
 	if (error)
@@ -609,7 +628,7 @@
 free1:
 	(void)soclose(so1);
 done2:
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	return (error);
 }
 
@@ -695,11 +714,12 @@
 	int iovlen;
 #endif
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, s, &so, NULL)) != 0)
 		goto bad2;
 
 #ifdef MAC
+	/* XXXRW: MAC requires socket lock? */
 	error = mac_check_socket_send(td->td_ucred, so);
 	if (error)
 		goto bad;
@@ -756,7 +776,7 @@
 bad:
 	fputsock(so);
 bad2:
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	return (error);
 }
 
@@ -936,17 +956,17 @@
 	int iovlen;
 #endif
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, s, &so, NULL)) != 0) {
-		mtx_unlock(&Giant);
+		NET_UNLOCK_GIANT();
 		return (error);
 	}
 
 #ifdef MAC
+	/* XXXRW: MAC requires socket lock? */
 	error = mac_check_socket_receive(td->td_ucred, so);
 	if (error) {
 		fputsock(so);
-		mtx_unlock(&Giant);
 		return (error);
 	}
 #endif
@@ -1070,7 +1090,7 @@
 	}
 out:
 	fputsock(so);
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	if (fromsa)
 		FREE(fromsa, M_SONAME);
 	if (control)
@@ -1285,12 +1305,12 @@
 	struct socket *so;
 	int error;
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, uap->s, &so, NULL)) == 0) {
 		error = soshutdown(so, uap->how);
 		fputsock(so);
 	}
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	return(error);
 }
 
@@ -1318,7 +1338,7 @@
 	if (uap->valsize < 0)
 		return (EINVAL);
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, uap->s, &so, NULL)) == 0) {
 		sopt.sopt_dir = SOPT_SET;
 		sopt.sopt_level = uap->level;
@@ -1329,7 +1349,7 @@
 		error = sosetopt(so, &sopt);
 		fputsock(so);
 	}
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	return(error);
 }
 
@@ -1353,7 +1373,7 @@
 	struct  socket *so;
 	struct	sockopt sopt;
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, uap->s, &so, NULL)) != 0)
 		goto done2;
 	if (uap->val) {
@@ -1383,7 +1403,7 @@
 done1:
 	fputsock(so);
 done2:
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	return (error);
 }
 
@@ -1408,7 +1428,7 @@
 	socklen_t len;
 	int error;
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, uap->fdes, &so, NULL)) != 0)
 		goto done2;
 	error = copyin(uap->alen, &len, sizeof (len));
@@ -1442,7 +1462,7 @@
 done1:
 	fputsock(so);
 done2:
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	return (error);
 }
 
@@ -1493,7 +1513,7 @@
 	socklen_t len;
 	int error;
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 	if ((error = fgetsock(td, uap->fdes, &so, NULL)) != 0)
 		goto done2;
 	if ((so->so_state & (SS_ISCONNECTED|SS_ISCONFIRMING)) == 0) {
@@ -1532,7 +1552,7 @@
 done1:
 	fputsock(so);
 done2:
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 	return (error);
 }
 
@@ -1686,7 +1706,7 @@
 	int error, s, headersize = 0, headersent = 0;
 	struct iovec *hdr_iov = NULL;
 
-	mtx_lock(&Giant);
+	NET_LOCK_GIANT();
 
 	hdtr_size = 0;
 
@@ -1718,6 +1738,7 @@
 	}
 
 #ifdef MAC
+	/* XXXRW: MAC requires socket lock? */
 	error = mac_check_socket_send(td->td_ucred, so);
 	if (error)
 		goto done;
@@ -1757,7 +1778,9 @@
 	/*
 	 * Protect against multiple writers to the socket.
 	 */
+	SOCKBUF_LOCK(&so->so_snd);
 	(void) sblock(&so->so_snd, M_WAITOK);
+	SOCKBUF_UNLOCK(&so->so_snd);
 
 	/*
 	 * Loop through the pages in the file, starting with the requested
@@ -1791,14 +1814,17 @@
 		 * Optimize the non-blocking case by looking at the socket space
 		 * before going to the extra work of constituting the sf_buf.
 		 */
+		SOCKBUF_LOCK(&so->so_snd);
 		if ((so->so_state & SS_NBIO) && sbspace(&so->so_snd) <= 0) {
 			if (so->so_state & SS_CANTSENDMORE)
 				error = EPIPE;
 			else
 				error = EAGAIN;
 			sbunlock(&so->so_snd);
+			SOCKBUF_UNLOCK(&so->so_snd);
 			goto done;
 		}
+		SOCKBUF_UNLOCK(&so->so_snd);
 		VM_OBJECT_LOCK(obj);
 		/*
 		 * Attempt to look up the page.
@@ -1887,7 +1913,9 @@
 			}
 			vm_page_unlock_queues();
 			VM_OBJECT_UNLOCK(obj);
+			SOCKBUF_LOCK(&so->so_snd);
 			sbunlock(&so->so_snd);
+			SOCKBUF_UNLOCK(&so->so_snd);
 			goto done;
 		}
 		vm_page_unlock_queues();
@@ -1903,7 +1931,9 @@
 			if (pg->wire_count == 0 && pg->object == NULL)
 				vm_page_free(pg);
 			vm_page_unlock_queues();
+			SOCKBUF_LOCK(&so->so_snd);
 			sbunlock(&so->so_snd);
+			SOCKBUF_UNLOCK(&so->so_snd);
 			error = EINTR;
 			goto done;
 		}
@@ -1940,6 +1970,7 @@
 		 * Add the buffer to the socket buffer chain.
 		 */
 		s = splnet();
+		SOCKBUF_LOCK(&so->so_snd);
 retry_space:
 		/*
 		 * Make sure that the socket is still able to take more data.
@@ -1961,6 +1992,7 @@
 			}
 			m_freem(m);
 			sbunlock(&so->so_snd);
+			SOCKBUF_UNLOCK(&so->so_snd);
 			splx(s);
 			goto done;
 		}
@@ -1973,6 +2005,7 @@
 			if (so->so_state & SS_NBIO) {
 				m_freem(m);
 				sbunlock(&so->so_snd);
+				SOCKBUF_UNLOCK(&so->so_snd);
 				splx(s);
 				error = EAGAIN;
 				goto done;
@@ -1992,14 +2025,20 @@
 			goto retry_space;
 		}
 		error = (*so->so_proto->pr_usrreqs->pru_send)(so, 0, m, 0, 0, td);
+		/* XXX: Why release and re-grab? */
+		SOCKBUF_UNLOCK(&so->so_snd);
 		splx(s);
 		if (error) {
+			SOCKBUF_LOCK(&so->so_snd);
 			sbunlock(&so->so_snd);
+			SOCKBUF_UNLOCK(&so->so_snd);
 			goto done;
 		}
 		headersent = 1;
 	}
+	SOCKBUF_LOCK(&so->so_snd);
 	sbunlock(&so->so_snd);
+	SOCKBUF_UNLOCK(&so->so_snd);
 
 	/*
 	 * Send trailers. Wimp out and use writev(2).
@@ -2046,7 +2085,7 @@
 	if (m_header)
 		m_freem(m_header);
 
-	mtx_unlock(&Giant);
+	NET_UNLOCK_GIANT();
 
 	if (error == ERESTART)
 		error = EINTR;
